// showthreshold.cc
// g++ -I/usr/include/SDL -D_REENTRANT -L/usr/lib -lSDL -lSDL_image -lpthread -o showthresholdGroot showthresholdGroot.cc

using namespace std;
#include<stdlib.h>
#include<iostream.h>
#include<SDL.h>
#include<SDL_image.h>
#include<string>
#include "convert.h"

/*
* Set the pixel at (x, y) to the given value
* NOTE: The surface must be locked before calling this!
*/
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
  *((Uint8 *)surface->pixels + y * surface->pitch + x) = pixel;
}

/*
 * Return the pixel value at (x, y)
 * NOTE: The surface must be locked before calling this!
 */
Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

class ThresholdStream
{
 public:
  ThresholdStream(int hT) 
  {
    hardThreshold = hT;
  }
  // simpele versie, wordt moeilijker als thresholden met spike-neuron
  // (dus class nodig want waardes bewaren).
  int threshold(int input)
  {
    return(input > hardThreshold);
  }
 private:
  int hardThreshold;
};

int main(int argc, char** argv)
{
//  string filenaam = "Anthony11.00001";
  string filenaam = "Ben12.00001";
  char *tellen = "0123456789";
  if(argc > 1)
    filenaam = argv[2];

  int schaal = 4;
  int threshold = 50;

  SDL_Event  event;
  SDL_Surface *plaatje, *screen;
  plaatje = IMG_Load(filenaam.c_str());
  SDL_Init(SDL_INIT_VIDEO);
  screen = SDL_SetVideoMode(plaatje->w * schaal, plaatje->h * schaal, 8, 0);
  SDL_SetColors(screen, plaatje->format->palette->colors, 0, plaatje->format->palette->ncolors); 

  Uint8 index;
  int tel = 0;
  int tel2 = 0;
  int x,y,xs, ys, p,rust; 
  
  do {
    for(p=0; p<7 && (event.type != SDL_QUIT); p++)
    {
      if (p<9) // wauw, hoe lelijk kan je het maken.
        filenaam += "0";
      filenaam += stringify(p+1);
//      cout << filenaam << endl;

      plaatje = IMG_Load(filenaam.c_str());
      SDL_LockSurface(plaatje);
      SDL_LockSurface(screen);
      for(y=0; y<plaatje->h; y++)
        for(x=0; x<plaatje->w; x++) {
           index= ((Uint8)getpixel(plaatje, x, y));     
           for(xs = schaal*x; xs < schaal* (x+1); xs++)
             for(ys = schaal*y; ys < schaal* (y+1); ys++)
             {

               if ( (int) index < threshold)
               {
                 putpixel(screen, xs, ys, 255);
                 tel2++;
               }
               else
                 putpixel(screen, xs, ys, 0);

//              putpixel(screen, xs, ys, index);
             }
        }
        
      SDL_UnlockSurface(screen);
      SDL_UpdateRect(screen, 0, 0, 0, 0);
      SDL_Delay(100);
      SDL_PollEvent(&event);
    }
    SDL_Delay(1000);
    SDL_PollEvent(&event);
    cout << threshold << " " << tel2 << endl;
    tel2 = 0;
//    threshold += 1;
  } while (event.type != SDL_QUIT);
  
  /*do {
    SDL_Delay(10);
    SDL_PollEvent(&event);
  } while (event.type != SDL_QUIT);
  */
  return(0);
}
