// showthresholdstoer.cc
// g++ -I/usr/include/SDL -D_REENTRANT -L/usr/lib -lSDL -lSDL_image -lpthread -o showthresholdstoer showthresholdstoer.cc

using namespace std;
#include<stdlib.h>
#include<iostream.h>
#include<fstream>
#include<SDL.h>
#include<SDL_image.h>
#include<string>
#include "convert.h"

/*
* Set the pixel at (x, y) to the given value
* NOTE: The surface must be locked before calling this!
*/
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
  *((Uint8 *)surface->pixels + y * surface->pitch + x) = pixel;
}

/*
 * Return the pixel value at (x, y)
 * NOTE: The surface must be locked before calling this!
 */
Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

class ThresholdStream
{
 public:
  ThresholdStream(int hT) 
  {
    hardThreshold = hT;
  }
  // simpele versie, wordt moeilijker als thresholden met spike-neuron
  // (dus class nodig want waardes bewaren).
  int threshold(int input)
  {
    return(input > hardThreshold);
  }
 private:
  int hardThreshold;
};

int numberOfFrames(string patnaam)
{
  ifstream aantallen("aantallen.data");
  int aantal;
  string patnaamfile;
  do
  {
    aantallen >> patnaamfile >> aantal;
  } while(patnaam != patnaamfile);
  return(aantal);
}
string returnAllPatNames()
{
  int aantal;
  string patnaamfile;
//  if(!aantallen)
    static ifstream aantallen("aantallen.data");
   aantallen >> patnaamfile >> aantal;
  return(patnaamfile);
}
  

int main(int argc, char** argv)
{

  int nrOfFrames;
  string patnaam = "Candace22";
  char *tellen = "0123456789";
  int scale = 1;

  if(argc > 1)
  {
    patnaam = argv[1];
  }
  if(argc > 2)
  {
    scale = atoi(argv[2]);
  }

  string filenaam = patnaam + ".00001";

  SDL_Event  event;
  SDL_Surface *plaatje, *screen;
  plaatje = IMG_Load(filenaam.c_str());
  SDL_Init(SDL_INIT_VIDEO);
  screen = SDL_SetVideoMode(plaatje->w*scale*2 + 10, plaatje->h*scale, 8, 0);
  SDL_SetColors(screen, plaatje->format->palette->colors, 0, plaatje->format->palette->ncolors); 

  Uint8 index;
  Uint8 indexBW;
  int tel = 0;
  int tel2 = 0;
  int threshold = 50;
  int i, xs, ys, x,y,p,rust; 
  
  cout << nrOfFrames << endl;
  for(i = 0; (i < 96) && (event.type != SDL_QUIT); i++)
  {
    patnaam = returnAllPatNames();
    cout << "using " << patnaam;
    nrOfFrames = numberOfFrames(patnaam);
    for(p=0; p<nrOfFrames && (event.type != SDL_QUIT); p++)
    {
      tel = 0;
      filenaam = patnaam + ".000";
      if (p<9) // wauw, hoe lelijk kan je het maken.
        filenaam += "0";
      filenaam += stringify(p+1);

      plaatje = IMG_Load(filenaam.c_str());
      SDL_LockSurface(plaatje);
      SDL_LockSurface(screen);
      for(y=0; y<plaatje->h; y++)
        for(x=0; x<plaatje->w; x++) {
           index= ((Uint8)getpixel(plaatje, x, y));     
           if ( (int) index < threshold)
           {
             indexBW = 255;
             tel2++;
           }
           else
             indexBW = 0;
           for(xs = scale*x; xs < scale* (x+1); xs++)
             for(ys = scale*y; ys < scale* (y+1); ys++)
             {
               putpixel(screen, xs, ys, index);
               putpixel(screen, xs + plaatje->w*scale + 10, ys, indexBW);
             }
           tel++;
        }
        
      SDL_UnlockSurface(screen);
      SDL_UpdateRect(screen, 0, 0, 0, 0);
      SDL_Delay(100);
      SDL_PollEvent(&event);
    }
    SDL_Delay(200);
    SDL_PollEvent(&event);
    cout << "  nrOfSpikes = " << tel2 << "  nrOfFrames = " << nrOfFrames << endl;
    tel2 = 0;
    SDL_PollEvent(&event);
  } 
  
  /*do {
    SDL_Delay(10);
    SDL_PollEvent(&event);
  } while (event.type != SDL_QUIT);
  */
  return(0);
}
